<?php

class helperActivhaCredit {
	static $fieldCurrentCredit = 'cb_marketing_currentcredit';
	static $fieldMaxCredit = 'cb_marketing_maxcredit';

	public static function getMaxCredit($userid){
		$db = JFactory::getDBO();

		$db->setQuery('SELECT '.self::$fieldMaxCredit.' AS credit FROM #__comprofiler WHERE user_id = '.intval($userid));
		$userCredit = $db->loadResult();
		if(!empty($userCredit)) return $userCredit;

		$db->setQuery('SELECT fields.default AS credit FROM #__comprofiler_fields fields WHERE tablecolumns = '.$db->Quote(self::$fieldMaxCredit));
		$defaultCredit = $db->loadResult();
		return $defaultCredit;
	}

	public static function getCreditLeft($userid){
		$db = JFactory::getDBO();
		$db->setQuery('SELECT '.self::$fieldCurrentCredit.' FROM #__comprofiler WHERE user_id = '.intval($userid));
		$result = $db->loadResult();

		return (!empty($result)) ? $result : 0;
	}

	public static function removeCredit($numberCredit, $userid){
		$db = JFactory::getDBO();
		$db->setQuery('SELECT '.self::$fieldCurrentCredit.' FROM  #__comprofiler  WHERE user_id = '.intval($userid));
		if(!$db->loadResult()){
			$db->setQuery('UPDATE #__comprofiler SET '.self::$fieldCurrentCredit.'=(SELECT fields.default AS credit FROM #__comprofiler_fields fields WHERE tablecolumns='.$db->Quote(self::$fieldCurrentCredit).') WHERE user_id='.intval($userid));
			$db->execute();
		}

		$db->setQuery('UPDATE #__comprofiler SET '.self::$fieldCurrentCredit.'='.self::$fieldCurrentCredit.'-'.intval($numberCredit).' WHERE user_id='.intval($userid));
		$db->execute();
	}

	public static function addCreditForPeriod($numberCredit, $userid){
		$db = JFactory::getDBO();
		$query = 'UPDATE #__comprofiler SET '.self::$fieldCurrentCredit.'='.self::$fieldCurrentCredit.'+'.intval($numberCredit).' WHERE user_id='.intval($userid);
		$db->setQuery($query);
		$db->execute();
	}

	public static function addCredit($numberCredit, $userid, $limit = true){
		$currentCredit = self::getCreditLeft($userid);
		$maxCredit = self::getMaxCredit($userid);

		if($limit && $numberCredit + $currentCredit > $maxCredit){
			$numberCredit = $numberCredit - (($currentCredit + $numberCredit) - $maxCredit);
		}
		$db = JFactory::getDBO();
		$query = 'UPDATE #__comprofiler SET '.self::$fieldCurrentCredit.'='.self::$fieldCurrentCredit.'+'.intval($numberCredit).' WHERE user_id='.intval($userid);
		$db->setQuery('UPDATE #__comprofiler SET '.self::$fieldCurrentCredit.'='.intval($numberCredit).' WHERE user_id='.intval($userid));
		$db->execute();
	}

}