<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );	

class plgActivhaAffiliatetracker extends JPlugin
{	

	public function plgActivhaAffiliatetracker(& $subject, $config)
	{
		
		$lang =& JFactory::getLanguage();
		$lang->load('com_affiliatetracker', JPATH_SITE);
		
		parent::__construct($subject, $config);

	}
	//todo find how to call acy confirm instead of changing frontusers.php file
// 	private function FrontusersControlleronAcyConfirm($user){
// 		$this->hotspotcoms($user);
// 	}		
	
	public function hotspotcoms($user){	
		//As we are in another component we need to import the helper.
		require_once(JPATH_SITE.DS.'components'.DS.'com_activha'.DS.'helpers'.DS.'credit.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_activha'.DS.'helpers'.DS.'tools.php');
		if (!$user->source) $source = helperActivhaTools::get_acysource_from_id($user->id); 
		else $source=$user->source;

		$iparr = preg_split ("/\-/", $source); 
		$approved = 1;
		$groups = JAccess::getGroupsByUser($user->id);
		 		
		//to do check $iparr[0] = cms user existing and approved
 		if ($iparr[0] > 0){
			//find activator
			$act_id = $iparr[3] ;
			//find marketing campaign owner if not in group, default to superadmin for future allocation
			if (in_array(18, $groups)){
				$cowner = $iparr[0] ;
				} else $cowner = 41 ;
			//find campaign id
			$campid = $iparr[1] ;
			//find hotspot number 
			$hotspot = $iparr[2];

			//Check if enough credits to pay the campaign
			$creditLeft = helperActivhaCredit::getCreditLeft($cowner);
			if($creditLeft < 15 ){
				//todo send email to cowner to add credit
			}
			
			if($creditLeft == 0 ){ $approved = 0; }
					
			//find value multiplier depending on cbfield and set activation value pre earned to 2 € (ie = 4)	
			if (in_array(18, $groups)){	
				$value = 2 * helperActivhaTools::get_mfl_from_userid($cowner);
			} else $value = 4;
			
			//todo find cowner company name with CB to set in extended name
			if (in_array(18, $groups)){
				$name = ("Campagne active: ". $campid ." - Activé : " . $user->name);
			} else {
				$name = ("Campagne souhaitée: ". $campid ." - Activé : " . $user->name);
			}
		
			//todo ?? split commissions between activator and MFL
			//todo check if activated not already in DB with combination email/acy userid/event id
					include(JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_affiliatetracker'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'helpers.php');
					
			//add commission to activator for this activation	
			$atid = AffiliateHelper::get_atid_from_id($act_id);	
			$conversion_data = array(
				"name" => $name,
				"component" => "com_activha",
				"extended_name" => "Activation photo sur campagne n° " . $campid,
				"type" => $campid . "cact",
				"value" => $value,
				"reference_id" => $iparr[0].$iparr[1].$iparr[2].$iparr[3],
				"approved" => $approved,
				"atid" => $atid,
			);
			AffiliateHelper::create_conversion($conversion_data, $cowner);
			
			//remove commission to campaign owner for this activation
			$atid_ow = AffiliateHelper::get_atid_from_id($cowner);	
			$conversion_data_ow = array(
				"name" => $name,
				"component" => "com_activha",
				"extended_name" => "Activation sur campagne n° " . $campid,
				"type" => $campid . "cmar",
				"value" => (-$value),
				"reference_id" => $iparr[3].$iparr[2].$iparr[1].$iparr[0],
				"approved" => $approved,
				"atid" => $atid_ow,
			);
			AffiliateHelper::create_conversion($conversion_data_ow, $act_id);
					
			//remove corresponding value to credit
			helperActivhaCredit::removeCredit($value,$cowner);
			if ($user->source > 0){
				$redirectUrl = 'https://activ-ha.com/c/'.$hotspot.'?atid='.$act_id;
				acym_redirect($redirectUrl);
			}
			
		}  
		return;
	}
	
	public function getnewcheck($user){
		require_once(JPATH_SITE.DS.'components'.DS.'com_activha'.DS.'helpers'.DS.'tools.php');	
		
		$check = helperActivhaTools::find_acy_user_hotspots($user->id);
		$newcheck = $check;
	
	return $newcheck;
	}
	
}


