<?php
defined('_JEXEC') or die;

jimport('joomla.application.component.controller');

if(!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

//We include AcyMailing to handle newsletter
include_once(rtrim(JPATH_ADMINISTRATOR, DS).DS.'components'.DS.'com_acym'.DS.'helpers'.DS.'helper.php');


$controllerRequest = JRequest::getCmd('ctrl');
if(empty($controllerRequest)){
	$controllerRequest = JRequest::getCmd('view');
}
else{
	JRequest::setVar('view', $controllerRequest);
}

$controllerName = ucfirst($controllerRequest).'Controller';

if(!include(dirname(__FILE__).DIRECTORY_SEPARATOR.'controllers'.DIRECTORY_SEPARATOR.$controllerRequest.'.php')){
	//If the controller is unknown we redirect the user
	$app = JFactory::getApplication();
	$app->redirect('index.php');
	return;
}

JHtml::stylesheet(JPATH_ROOT.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'com_maily'.DIRECTORY_SEPARATOR.'style.css', array(), true);

$controller = new $controllerName();

$task = JRequest::getCmd('task');
if(empty($task)){
	$task = JRequest::getCmd('layout');
}
else{
	JRequest::setVar('layout', $task);
}

$controller->execute($task);
JRequest::setVar('view', $controller->getName());

$controller->redirect();