<?php

class helperActivhaTools {

	static function navigation_tabs(){

			$params =JComponentHelper::getParams( 'com_activha' );
			$itemid = $params->get('itemid');
			if($itemid != "") $itemid = "&Itemid=" . $itemid;

			$link_conversions = JRoute::_("index.php?option=com_acym&view=frontsubscriber&layout=listing" . $itemid) ;
			$link_logs = JRoute::_("index.php?option=com_comprofiler&view=pluginclass&plugin=cbgroupjive&action=categories&id=13" . $itemid) ;
			$link_account = JRoute::_("index.php?option=com_acym&view=stats&layout=listing" . $itemid) ;
			$link_payments = JRoute::_("index.php?option=com_affiliatetracker&view=payments" . $itemid) ;
			$link_marketings = JRoute::_("index.php?option=com_affiliatetracker&view=marketings" . $itemid) ;

			$view = JRequest::getVar('view');

			$class_conversions = "class='nav-link text-white border rounded-0'" ;
			$class_logs = "class='nav-link text-white border rounded-0'" ;
			$class_account = "class='nav-link text-white border rounded-0 '" ;
			$class_payments = "class='nav-link text-white border rounded-0 '" ;
			$class_marketings = "class='nav-link text-white border rounded-0'";

			switch($view){
				case "conversions":
					$class_conversions = "class='nav-link active text-white border rounded-0'" ;
				break;
				case "logs":
					$class_logs = "class='nav-link active text-white border rounded-0'" ;
				break;
				case "accounts":
					$class_account = "class='nav-link active text-white border rounded-0'" ;
				break;
				case "payments":
					$class_payments = "class='nav-link active text-white border rounded-0'" ;
				break;
				case "marketings":
					$class_marketings = "class='nav-link active text-white border rounded-0'" ;
			}

			//$return = "<nav class='navbar navbar-expand-lg navbar-light bg-light'> <a class='navbar-brand' href='#'>Activateur</a>  <button class='navbar-toggler' type='button' data-toggle='collapse' data-target='#navbarNav' aria-controls='navbarNav' aria-expanded='false' aria-label='Toggle navigation'> <span class='navbar-toggler-icon'></span> </button> <div class='collapse navbar-collapse' id='navbarNav'>";
			$return .= "<ul class='nav nav-pills nav-fill bg-secondary bg-gradient-secondary'>
			  <li class='nav-item'><a ".$class_conversions." href='".$link_conversions."'><i class='fad fa-euro-sign fa-lg' style='--fa-secondary-color:#d5fe6c;--fa-secondary-opacity: 1;'></i>". JText::_('CONVERSIONS') ."</a></li>
			  <li class='nav-item'><a ".$class_logs." href='".$link_logs."'><i class='fad fa-stream fa-lg' style='--fa-secondary-color:#d5fe6c;--fa-secondary-opacity: 1;'></i>". JText::_('TRAFFIC_LOGS') ."</a></li>
			  <li class='nav-item'><a ".$class_marketings." href='".$link_marketings."'><i class='fad fa-layer-plus fa-lg' style='--fa-secondary-color:#d5fe6c;--fa-secondary-opacity: 1;'></i>". JText::_('MARKETINGS') ."</a></li>
			  <li class='nav-item'><a ".$class_account." href='".$link_account."'><i class='fad fa-user-friends fa-lg' style='--fa-secondary-color:#d5fe6c;--fa-secondary-opacity: 1;'></i>". JText::_('MY_ACCOUNT') ."</a></li>		  
			  <li class='nav-item'><a ".$class_payments." href='".$link_payments."'><i class='fad fa-money-check-edit fa-lg' style='--fa-secondary-color:#d5fe6c;--fa-secondary-opacity: 1;'></i>". JText::_('PAYMENTS') ."</a></li>
			</ul>";
			//$return .= "</div></nav>";

			return $return ;

		}
	
	static function get_mfl_from_userid($userid){
		if($userid){
			$db = JFactory::getDBO();
			$query = " SELECT cb_marketing_multiplier FROM #__comprofiler WHERE user_id = " . (int)$userid ;
			$db->setQuery($query);
			$result = $db->loadResult();

			return $result;
		}
		else return "";
	}
	
	static function get_acy_from_source($source){
		if($source){
			$db = JFactory::getDBO();
			$query = " SELECT id FROM #__acym_user WHERE source = " . $source ;
			$db->setQuery($query);
			$result = $db->loadResult();

			return $result;
		}
		else return "";
	}	
	
	static function get_acysource_from_id($id){
		if($id){
			$db = JFactory::getDBO();
			$query = " SELECT source FROM #__acym_user WHERE id = " . $id ;
			$db->setQuery($query);
			$result = $db->loadResult();

			return $result;
		}
		else return "";
	}	
		
	//update acym field hotspotchecks	
	static function update_acy_user_hotspots($userid, $value){
		if($userid){
			$db = JFactory::getDBO();
			$query = " INSERT INTO #__acym_user_has_field (user_id, field_id, value) VALUES ( ".$userid." ,18, ".$value.") ON DUPLICATE KEY UPDATE value = " . $value;
			$db->setQuery($query);
			$result = $db->loadResult();

			return $result;
		}
		else return "";
	}	
	
	static function find_acy_user_hotspots($userid){
		if($userid){
			$db = JFactory::getDBO();
			$query = " SELECT value FROM #__acym_user_has_field WHERE field_id = 18 AND user_id = " . $userid ;
			$db->setQuery($query);
			$result = $db->loadResult();

			return $result;
		}
		else return "";
	}		
}