<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class newsletterViewnewsletter extends JViewLegacy{
	public $document;

	public function display($tpl = null){
		JHtml::_('jquery.framework');

		$this->document = JFactory::getDocument();
		$this->document->addStylesheet(JURI::base().'media/com_maily/css/grid.css');
		$this->document->addStylesheet(JURI::base().'media/com_maily/css/style.css');
		$this->document->addStylesheet(JURI::base().'media/com_maily/lib/css/font-awesome.min.css');
		$this->document->addStylesheet(JURI::base().'media/com_maily/lib/css/toastr.min.css');
		$this->document->addScript(JURI::base().'media/com_maily/lib/js/toastr.min.js');

		$function = $this->getLayout();
		if(method_exists($this, $function)) $this->$function();

		parent::display($tpl);
	}

	public function create(){
		$this->document->addStylesheet(JURI::base().'media/com_maily/lib/css/vex.css');
		$this->document->addScript(JURI::base().'media/com_maily/lib/ckeditor/ckeditor.js');
		$this->document->addScript(JURI::base().'media/com_maily/lib/js/sortable.js');
		$this->document->addScript(JURI::base().'media/com_maily/lib/js/vex.combined.min.js');
		$this->document->addScriptDeclaration('vex.defaultOptions.className = "vex-theme-os"');
		$this->document->addScript(JURI::base().'media/com_maily/js/editor.js');

		$this->id = JRequest::getInt('newsletter-id', -1);
		if($this->id > 0){
			$session = JFactory::getSession();
			$this->jsonNewsletter = $session->get('maily-newsletter', '');
		}

		$this->previousStep = JRoute::_('index.php?option=com_maily&ctrl=stats&task=listing', false);
	}

	public function design(){
		$me = JFactory::getUser();
		$this->document->addScript(JURI::base().'media/com_maily/js/design.js');

		$this->id = JRequest::getInt('newsletter-id', -1);
		$newsletter = helperNewsletter::getNewsletter($this->id);
		$this->templates = helperNewsletter::getTemplates();
		$this->content = str_replace(array('<style>', '</style>'), array('<acystyle></acystyle>'), $newsletter->body);
		$this->previousStep = JRoute::_('index.php?option=com_maily&ctrl=newsletter&task=create&newsletter-id='.$this->id, false);
		$this->defaultEmail = (empty($me->email)) ? '' : $me->email;
	}

	public function receiver(){
		$this->document->addScript(JURI::base().'media/com_maily/js/receiver.js');
		$this->document->addScript(JURI::base().'media/com_maily/js/spinner.js');

		$listClass = acymailing_get('class.list');

		$filterFiles = scandir(dirname(__FILE__).DS.'filters');
		$excludedFiles = array('.', '..', 'index.html');
		$filterName = array();
		$filterName[''] = '---------';
		foreach($filterFiles as $oneFile){
			if(in_array($oneFile, $excludedFiles)) continue;
			$fileName = str_replace('.php', '', $oneFile);
			$filterName[$fileName] = ucfirst($fileName);
			include(dirname(__FILE__).DS.'filters'.DS.$oneFile);
		}

		$options = array();
		foreach($filterName as $key => $value){
			$options[] = JHTML::_('select.option', $key, $value);
		}

		$this->acymailingList = $listClass->getFrontendLists();
		$this->typeOfField = JHTML::_('select.genericlist', $options, 'filternames[0]', 'class="ajax-preview filter-name"', 'value', 'text', '1');
		$this->id = JRequest::getInt('newsletter-id', -1);

		$this->previousStep = JRoute::_('index.php?option=com_maily&ctrl=newsletter&task=design&newsletter-id='.$this->id, false);
	}

	public function send(){
		$me = JFactory::getUser();

		$filters = array();
		$filters['lists'] = JRequest::getVar('lists', array());
		$filters['filternames'] = JRequest::getVar('filternames', array());
		$filters['values'] = JRequest::getVar('values', array());
		$filters['operators'] = JRequest::getVar('operators', array());
		$filters['columns'] = JRequest::getVar('columns', array());

		$numberReceiver = helperFilter::getReceivers($filters['lists'], $filters['columns'], $filters['filternames'], $filters['values'], $filters['operators'], true);

		$this->id = JRequest::getInt('newsletter-id', -1);
		$this->filters = urlencode(json_encode($filters));

		$creditLeft = helperCredit::getCreditLeft($me->id);
		if($numberReceiver > $creditLeft){
			$this->message = 'Attention vous n\'avez pas assez de crédit pour envoyer un message à  <span id="number">'.$numberReceiver.'</span> personnes. Il vous reste '.$creditLeft.' credits';
			$this->task = 'listing';
			$this->ctrl = 'stats';
			$this->button = 'Annuler';
		}
		else{
			$this->message = 'Votre lettre d\'information va être envoyée à  <span id="number">'.$numberReceiver.'</span> personnes. Il vous restera '.($creditLeft - $numberReceiver).' credits après l\'envoi.';
			$this->task = 'sendNewsletter';
			$this->ctrl = 'newsletter';
			$this->button = 'Envoyer !';
		}
	}
}