<?php
/*------------------------------------------------------------------------
# plg_affiliatetracker_invoicemanager - Affiliate Tracker for Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2014 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.JoomlaThat.com
# Technical Support:	Forum - http://www.JoomlaThat.com/support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

//new for Joomla 3.0
if(!defined('DS')){
define('DS',DIRECTORY_SEPARATOR);
}

class  plgInvoicesAffiliatetracker extends JPlugin
{
	
	function plgInvoicesAffiliatetracker(& $subject, $config)
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_affiliatetracker', JPATH_SITE);

		parent::__construct($subject, $config);

	}
	
	function onAfterSavePayment($payment) {

		//only attempt to create the conversion if the order status is CONFIRMED
		if($payment->payment_status == 1){

			$db = JFactory::getDBO();

			//we check if this particular order had already been tracked
			$query = " SELECT id FROM #__affiliate_tracker_conversions WHERE component = 'com_invoices' AND type = 1 AND reference_id = ".$payment->id;
			$db->setQuery($query);
			$exists = $db->loadResult();

			//if it didn't exist, we attemp to create the conversion
			if(!$exists){

				$query = " SELECT invoice_id FROM #__invoices_payments WHERE id = ".$payment->id;
				$db->setQuery($query);
				$invoice_id = $db->loadResult();

				$query = " SELECT co.user_id FROM #__invoices_invoices AS i LEFT JOIN #__invoices_contacts AS co ON co.id = i.user_id WHERE i.id = ".$invoice_id;
				$db->setQuery($query);
				$user_id = $db->loadResult();

				$conversion_data = array(
										"name" => "Invoice Manager payment",
										"component" => "com_invoices",
										"extended_name" => $payment->payment_description,
										"type" => 1,
										"value" => (float)$payment->payment_amount ,
										"reference_id" => $payment->id,
										"approved" => $this->params->get('activation'),
										"atid" => 0
									);
				
				require_once(JPATH_SITE.DS.'components'.DS.'com_affiliatetracker'.DS.'helpers'.DS.'helpers.php');
				AffiliateHelper::create_conversion($conversion_data, $user_id);
			}

		}
	}
	
}